# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_blueprint_lib.api_client import ApiClient


class BlueprintRequestsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def cancel_blueprint_request_using_post(self, request_id, **kwargs):  # noqa: E501
        """Cancel request  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cancel_blueprint_request_using_post(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.cancel_blueprint_request_using_post_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.cancel_blueprint_request_using_post_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def cancel_blueprint_request_using_post_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Cancel request  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cancel_blueprint_request_using_post_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cancel_blueprint_request_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in params or
                params['request_id'] is None):
            raise ValueError("Missing the required parameter `request_id` when calling `cancel_blueprint_request_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in params:
            path_params['requestId'] = params['request_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests/{requestId}/actions/cancel', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_blueprint_request_using_post(self, body, **kwargs):  # noqa: E501
        """Creates a blueprint request  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_request_using_post(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiBlueprintrequestsBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintrequestsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_blueprint_request_using_post_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_blueprint_request_using_post_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_blueprint_request_using_post_with_http_info(self, body, **kwargs):  # noqa: E501
        """Creates a blueprint request  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_request_using_post_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiBlueprintrequestsBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintrequestsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_blueprint_request_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_blueprint_request_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiBlueprintrequestsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_blueprint_request_using_delete(self, request_id, **kwargs):  # noqa: E501
        """Deletes request  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_blueprint_request_using_delete(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool force: Force delete if not in final stage
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_blueprint_request_using_delete_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_blueprint_request_using_delete_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def delete_blueprint_request_using_delete_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Deletes request  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_blueprint_request_using_delete_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool force: Force delete if not in final stage
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_id', 'force', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_blueprint_request_using_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in params or
                params['request_id'] is None):
            raise ValueError("Missing the required parameter `request_id` when calling `delete_blueprint_request_using_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in params:
            path_params['requestId'] = params['request_id']  # noqa: E501

        query_params = []
        if 'force' in params:
            query_params.append(('force', params['force']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests/{requestId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_request_execution_using_get(self, request_id, **kwargs):  # noqa: E501
        """Returns request execution details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_request_execution_using_get(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool expand: Detailed execution
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20014
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_request_execution_using_get_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_request_execution_using_get_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def get_blueprint_request_execution_using_get_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Returns request execution details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_request_execution_using_get_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool expand: Detailed execution
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20014
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_id', 'expand', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_request_execution_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in params or
                params['request_id'] is None):
            raise ValueError("Missing the required parameter `request_id` when calling `get_blueprint_request_execution_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in params:
            path_params['requestId'] = params['request_id']  # noqa: E501

        query_params = []
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests/{requestId}/execution', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20014',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_request_using_get(self, request_id, **kwargs):  # noqa: E501
        """Returns blueprint request details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_request_using_get(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintrequestsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_request_using_get_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_request_using_get_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def get_blueprint_request_using_get_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Returns blueprint request details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_request_using_get_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintrequestsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_request_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in params or
                params['request_id'] is None):
            raise ValueError("Missing the required parameter `request_id` when calling `get_blueprint_request_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in params:
            path_params['requestId'] = params['request_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests/{requestId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiBlueprintrequestsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_resources_plan_using_get(self, request_id, **kwargs):  # noqa: E501
        """Returns request resources plan  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_resources_plan_using_get(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool expand: Detailed plan
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_resources_plan_using_get_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_resources_plan_using_get_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def get_blueprint_resources_plan_using_get_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Returns request resources plan  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_resources_plan_using_get_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool expand: Detailed plan
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_id', 'expand', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_resources_plan_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in params or
                params['request_id'] is None):
            raise ValueError("Missing the required parameter `request_id` when calling `get_blueprint_resources_plan_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in params:
            path_params['requestId'] = params['request_id']  # noqa: E501

        query_params = []
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests/{requestId}/resources-plan', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_blueprint_resources_plan_using_get1(self, request_id, **kwargs):  # noqa: E501
        """Returns request plan  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_resources_plan_using_get1(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool expand: Detailed plan
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20013
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_blueprint_resources_plan_using_get1_with_http_info(request_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_blueprint_resources_plan_using_get1_with_http_info(request_id, **kwargs)  # noqa: E501
            return data

    def get_blueprint_resources_plan_using_get1_with_http_info(self, request_id, **kwargs):  # noqa: E501
        """Returns request plan  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_blueprint_resources_plan_using_get1_with_http_info(request_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str request_id: (required)
        :param bool expand: Detailed plan
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20013
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['request_id', 'expand', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_blueprint_resources_plan_using_get1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'request_id' is set
        if ('request_id' not in params or
                params['request_id'] is None):
            raise ValueError("Missing the required parameter `request_id` when calling `get_blueprint_resources_plan_using_get1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'request_id' in params:
            path_params['requestId'] = params['request_id']  # noqa: E501

        query_params = []
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests/{requestId}/plan', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20013',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_blueprint_requests_using_get(self, **kwargs):  # noqa: E501
        """Lists blueprint requests  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_blueprint_requests_using_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] select: Fields to include in content.
        :param str deployment_id: Deployment Id filter
        :param bool include_plan: Plan Requests filter
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy.
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_blueprint_requests_using_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_blueprint_requests_using_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_blueprint_requests_using_get_with_http_info(self, **kwargs):  # noqa: E501
        """Lists blueprint requests  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_blueprint_requests_using_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param list[str] select: Fields to include in content.
        :param str deployment_id: Deployment Id filter
        :param bool include_plan: Plan Requests filter
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy.
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'size', 'sort', 'select', 'deployment_id', 'include_plan', 'api_version', 'top', 'skip', 'orderby']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_blueprint_requests_using_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'select' in params:
            query_params.append(('$select', params['select']))  # noqa: E501
            collection_formats['$select'] = 'multi'  # noqa: E501
        if 'deployment_id' in params:
            query_params.append(('deploymentId', params['deployment_id']))  # noqa: E501
        if 'include_plan' in params:
            query_params.append(('includePlan', params['include_plan']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-requests', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2006',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
